/**********************************************************************************************************************************/
/* Project      : HARDWARE                                                                                                        */
/* Module       : HARDWARE.C                                                                                                      */
/* Description  : Creates HARDWARE.INC binary runtime include file for TAPER                                                      */
/* Version type : Full program                                                                                                    */
/* Last changed : 06-09-1998  11:00                                                                                               */
/* Update count : 2                                                                                                               */
/* OS type      : PC (DOS)                                                                                                        */
/* Compiler     : Watcom C32 Optimizing Compiler Version 10.x                                                                     */
/* Linker       : Watcom C Linker                                                                                                 */
/*                                                                                                                                */
/*                Copyleft (C) 1997-2001 ThunderWare Research Center, written by Martijn van der Heide.                           */
/*                                                                                                                                */
/*                This program is free software; you can redistribute it and/or                                                   */
/*                modify it under the terms of the GNU General Public License                                                     */
/*                as published by the Free Software Foundation; either version 2                                                  */
/*                of the License, or (at your option) any later version.                                                          */
/*                                                                                                                                */
/*                This program is distributed in the hope that it will be useful,                                                 */
/*                but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  */
/*                MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   */
/*                GNU General Public License for more details.                                                                    */
/*                                                                                                                                */
/*                You should have received a copy of the GNU General Public License                                               */
/*                along with this program; if not, write to the Free Software                                                     */
/*                Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                                     */
/*                                                                                                                                */
/**********************************************************************************************************************************/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>

#define HWTYPES 16

char HWNames[HWTYPES][32] =   { "Computers",                       // 00
                                "External Storage",                // 01
                                "ROM/RAM Type Add-ons",            // 02
                                "Sound Devices",                   // 03
                                "Joysticks",                       // 04
                                "Mice",                            // 05
                                "Other Controllers",               // 06
                                "Serial Ports",                    // 07
                                "Parallel Ports",                  // 08
                                "Printers",                        // 09
                                "Modems",                          // 0A
                                "Digitisers",                      // 0B
                                "Network Adapters",                // 0C
                                "Keyboards & Keypads",             // 0D
                                "AD/DA Converters",                // 0E
                                "EPROM Programmers"                // 0F
                              };

char HWId[HWTYPES][32][32] = {{ "ZX Spectrum 16K",                 // 00.00
                                "ZX Spectrum 48K, +",              // 00.01
                                "ZX Spectrum 48K, issue 1",        // 00.02
                                "ZX Spectrum 128K (Sinclair)",     // 00.03
                                "ZX Spectrum +2 (Gray case)",      // 00.04
                                "ZX Spectrum +2A, +3",             // 00.05
                                "Timex Sinclair TS-2048",          // 00.06
                                "Timex Sinclair TS-2068",          // 00.07
                                "Pentagon 128",                    // 00.08
                                "Sam Coupe",                       // 00.09
                                "Didaktik M",                      // 00.0A
                                "Didaktik Gamma",                  // 00.0B
                                "ZX-81/TS-1000 1K RAM",            // 00.0C
                                "ZX-81/TS-1000 16K+ RAM",          // 00.0D
                                "ZX Spectrum 128K, Spanish",       // 00.0E
                                "ZX Spectrum, Arabic",             // 00.0F
                                "TK 90-X",                         // 00.10
                                "TK 95",                           // 00.11
                                "Byte",                            // 00.12
                                "Elwro",                           // 00.13
                                "ZS Scorpion",                     // 00.14
                                "Amstrad CPC 464",                 // 00.15
                                "Amstrad CPC 664",                 // 00.16
                                "Amstrad CPC 6128",                // 00.17
                                "Amstrad CPC 464+",                // 00.18
                                "Amstrad CPC 6128+",               // 00.19
                                "Jupiter ACE",                     // 00.1A
                                "Enterprise",                      // 00.1B
                                "Commodore 64",                    // 00.1C
                                "Commodore 128"                 }, // 00.1D

                              { "Microdrive",                      // 01.00
                                "Opus Discovery",                  // 01.01
                                "Disciple",                        // 01.02
                                "Plus-D",                          // 01.03
                                "Rotronics Wafadrive",             // 01.04
                                "TR-DOS (BetaDisk)",               // 01.05
                                "Byte Drive",                      // 01.06
                                "Watsford",                        // 01.07
                                "FIZ",                             // 01.08
                                "Radofin",                         // 01.09
                                "Didaktik Disk Drives",            // 01.0A
                                "BS-DOS (MB-02)",                  // 01.0B
                                "ZX Spectrum +3 Disk Drive",       // 01.0C
                                "JLO (Oliger) Disk Interface",     // 01.0D
                                "FDD3000",                         // 01.0E
                                "Zebra Disk Drive",                // 01.0F
                                "Ramex Millenia",                  // 01.10
                                "Larken"                        }, // 01.11

                              { "Sam Ram",                         // 02.00
                                "Multiface",                       // 02.01
                                "Multiface 128",                   // 02.02
                                "Multiface +3",                    // 02.03
                                "MultiPrint",                      // 02.04
                                "MB-02 ROM/RAM Expansion"       }, // 02.05

                              { "Classic AY Hardware (as 128K)",   // 03.00
                                "Fuller Box AY Sound Hardware",    // 03.01
                                "Currah MicroSpeech",              // 03.02
                                "SpecDrum",                        // 03.03
                                "AY ACB Stereo/Melodik",           // 03.04
                                "AY ABC Stereo"                 }, // 03.05

                              { "Kempston",                        // 04.00
                                "Cursor/Protek/AGF",               // 04.01
                                "ZX Interface 2 left (12345)",     // 04.02
                                "ZX Interface 2 right (67890)",    // 04.03
                                "Fuller"                        }, // 04.04

                              { "AMX Mouse",                       // 05.00
                                "Kempston Mouse",               }, // 05.01

                              { "TrickStick",                      // 06.00
                                "ZX Light Gun",                    // 06.01
                                "Zebra Graphics Tablet"         }, // 06.02

                              { "ZX Interface 1",                  // 07.00
                                "ZX Spectrum 128K"              }, // 07.01

                              { "Kempston S",                      // 08.00
                                "Kempston E",                      // 08.01
                                "ZX Spectrum +3",                  // 08.02
                                "Tasman Interface",                // 08.03
                                "DK\'Tronics",                     // 08.04
                                "Hilderbay",                       // 08.05
                                "INES Printerface",                // 08.06
                                "ZX LPrint Interface 3",           // 08.07
                                "MultiPrint",                      // 08.08
                                "Opus Discovery",                  // 08.09
                                "Standard 8255, Ports 31,63,95" }, // 08.0A

                              { "ZX Printer/Alphacom 32",          // 09.00
                                "Generic Printer",                 // 09.01
                                "EPSON Compatible"              }, // 09.02

                              { "VTX 5000",                        // 0A.00
                                "TS 2050/Westridge 2050"        }, // 0A.01

                              { "RD Digital Tracer",               // 0B.00
                                "DK\'Tronics Light Pen",           // 0B.01
                                "British MicroGraph Pad"        }, // 0B.02
 
                              { "ZX Interface 1"                }, // 0C.00
 
                              { "Keypad for ZX Spectrum 128K"   }, // 0D.00
 
                              { "Harley Systems ADC 8.2",          // 0E.00
                                "Blackboard Electronics"        }, // 0E.01
 
                              { "Orme Electronics"              }  // 0F.00
 
                            }; 

struct
{
  unsigned char NumHWTypes;
  unsigned char NumSubTypes;
  unsigned char MaxLength;
  unsigned char __Padding;
} Header = { HWTYPES, 32, 32 };

int main (int argc, char **argv)
{
  int Fh;

  Fh = open ("hardware.inc", O_RDWR | O_CREAT, 0777);
  write (Fh, &Header, sizeof (Header));
  write (Fh, HWNames, sizeof (HWNames));
  write (Fh, HWId, sizeof (HWId));
  close (Fh);
  return (0);
}
