/**********************************************************************************************************************************/
/* Project      : TAPER                                                                                                           */
/* Module       : TPCONFIG.H                                                                                                      */
/* Description  : Configuration handler                                                                                           */
/* Version type : Module interface                                                                                                */
/* Last changed : 08-06-1999  19:35                                                                                               */
/* Update count : 17                                                                                                              */
/* OS type      : PC (DOS)                                                                                                        */
/* Compiler     : Watcom C32 Optimizing Compiler Version 10.x                                                                     */
/* Linker       : Watcom C Linker                                                                                                 */
/*                                                                                                                                */
/*                Copyleft (C) 1997-2001 ThunderWare Research Center, written by Martijn van der Heide.                           */
/*                                                                                                                                */
/*                This program is free software; you can redistribute it and/or                                                   */
/*                modify it under the terms of the GNU General Public License                                                     */
/*                as published by the Free Software Foundation; either version 2                                                  */
/*                of the License, or (at your option) any later version.                                                          */
/*                                                                                                                                */
/*                This program is distributed in the hope that it will be useful,                                                 */
/*                but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  */
/*                MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   */
/*                GNU General Public License for more details.                                                                    */
/*                                                                                                                                */
/*                You should have received a copy of the GNU General Public License                                               */
/*                along with this program; if not, write to the Free Software                                                     */
/*                Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                                     */
/*                                                                                                                                */
/**********************************************************************************************************************************/

#ifndef TPCONFIG_H_INC
#define TPCONFIG_H_INC

#ifdef EXTERN
#undef EXTERN
#endif
#ifdef __TPCONFIG_MAIN__
#define EXTERN
#else
#define EXTERN extern
#endif

#define CONFIGEXT             ".INI"

#define ET_Z80                0
#define ET_JPP                1
#define ET_WAR                2
#define ET_X128               3
#define ET_WSPECEM            4
#define MAXETYPE              5

/**********************************************************************************************************************************/
/* Define the global variables                                                                                                    */
/**********************************************************************************************************************************/

struct TPConfig_s
{
  bool                         RemapBrightBlack;
  bool                         EmulateFlash;
  bool                         SlowFlash;
  bool                         ConfirmQuit;
  bool                         ConfirmDelete;
  bool                         ConfirmOverwrite;
  bool                         AlwaysBackupTape;
  word                         BlankerTimeOut;
  bool                         BlankerOn;
  bool                         PreLoadResources;
  bool                         DirectVideoControl;
  bool                         UseCustomPalette;
  bool                         TraceSoundBlocks;
  bool                         ShowRemainingPlayTime;
  bool                         ParPlayIRQsDisabled;
  bool                         SBNoHighSpeedDMA;
  bool                         DefUseFilter;
  bool                         DefDecodeROM;
  char                         EditPath[MAXDIR];
  char                         ZXEditPath[MAXDIR];
  char                         GIFViewerPath[MAXDIR];
  char                         JPGViewerPath[MAXDIR];
  char                         GIFViewerOptions[MAXDIR];
  char                         JPGViewerOptions[MAXDIR];
  char                         SampleValues[16];
  byte                         LPTPort;
  byte                         COMPort;
  word                         LPTAddr[3];
  word                         COMAddr[4];
  bool                         PlaySoundBlaster;
  bool                         PlayCriticalSection;
  bool                         TZXStripPauseLengths;
  dword                        CustomColor00;
  dword                        CustomColor01;
  dword                        CustomColor02;
  dword                        CustomColor03;
  dword                        CustomColor04;
  dword                        CustomColor05;
  dword                        CustomColor06;
  dword                        CustomColor07;
  dword                        CustomColor08;
  dword                        CustomColor09;
  dword                        CustomColor10;
  dword                        CustomColor11;
  dword                        CustomColor12;
  dword                        CustomColor13;
  dword                        CustomColor14;
  dword                        CustomColor15;
  char                         MouseSpeedString[80];
};

EXTERN struct TPConfig_s         TPConfig;
EXTERN char                      ConfigFile[MAXDIR];
EXTERN bool                      _InvalidPort;

EXTERN struct WindowInfo         AboutWindow;

/**********************************************************************************************************************************/
/* Define the interface functions                                                                                                 */
/**********************************************************************************************************************************/

void ReadConfig     (void);
void WriteConfig    (void);
void ChangeConfig   (void);
void AboutBox       (bool MakeWindow);
void SysInfoBox     (void);

#endif
